Loading...
Searching...
No Matches
casacore::Adios2StMan Class Reference

`#include <Adios2StMan.h>`

## Classes

struct | from_config_t
| tag for differentiating string-based constructors More...
class | impl

## Public Member Functions

| Adios2StMan (MPI_Comm mpiComm, std::string engineType={}, std::map< std::string, std::string > engineParams={}, std::vector< std::map< std::string, std::string > > transportParams={}, std::vector< std::map< std::string, std::string > > operatorParams={})
| Adios2StMan (MPI_Comm mpiComm, std::string configFile, from_config_t)
| Adios2StMan (std::string engineType={}, std::map< std::string, std::string > engineParams={}, std::vector< std::map< std::string, std::string > > transportParams={}, std::vector< std::map< std::string, std::string > > operatorParams={})
| Adios2StMan (std::string configFile, from_config_t)
virtual | ~Adios2StMan ()
virtual DataManager * | clone () const
| Make a clone of the derived object.
virtual String | dataManagerType () const
| Return the type name of the data manager (in fact its class name).
void | setDataManagerName (const String &aName)
virtual String | dataManagerName () const
| Return the name of the data manager.
virtual void | create64 (rownr_t aNrRows)
| Let the data manager initialize itself for a new table.
virtual rownr_t | open64 (rownr_t aRowNr, AipsIO &ios)
| Let the data manager initialize itself for an existing table.
virtual rownr_t | resync64 (rownr_t aRowNr)
| Resync the data by rereading cached data from the file.
virtual Bool | flush (AipsIO &, Bool doFsync)
| Flush and optionally fsync the data.
virtual DataManagerColumn * | makeScalarColumn (const String &aName, int aDataType, const String &aDataTypeID)
| Create a column in the data manager on behalf of a table column.
virtual DataManagerColumn * | makeDirArrColumn (const String &aName, int aDataType, const String &aDataTypeID)
| Create a direct array column.
virtual DataManagerColumn * | makeIndArrColumn (const String &aName, int aDataType, const String &aDataTypeID)
| Create an indirect array column.
virtual void | deleteManager ()
| The data manager will be deleted (because all its columns are requested to be deleted).
virtual void | addRow64 (rownr_t aNrRows)
| Add rows to all columns.
Record | dataManagerSpec () const
| Return a record containing data manager specifications.
rownr_t | getNrRows ()
Public Member Functions inherited from casacore::DataManager
| DataManager ()
| Default constructor.
virtual | ~DataManager ()
| DataManager (const DataManager &)=delete
| The copy constructor cannot be used for this base class.
DataManager & | operator= (const DataManager &)=delete
| Assignment cannot be used for this base class.
void | dataManagerInfo (Record &info) const
| Add SEQNR and SPEC (the DataManagerSpec subrecord) to the info.
virtual Record | getProperties () const
| Get data manager properties that can be modified.
virtual void | setProperties (const Record &spec)
| Modify data manager properties given in record fields.
virtual Bool | isStorageManager () const
| Is the data manager a storage manager?
virtual Bool | canReallocateColumns () const
| Tell if the data manager wants to reallocate the data manager column objects.
virtual DataManagerColumn * | reallocateColumn (DataManagerColumn *column)
| Reallocate the column object if it is part of this data manager.
uInt | sequenceNr () const
| Get the (unique) sequence nr of this data manager.
uInt | ncolumn () const
| Get the nr of columns in this data manager (can be zero).
Bool | asBigEndian () const
| Have the data to be stored in big or little endian canonical format?
const TSMOption & | tsmOption () const
| Get the TSM option.
std::shared_ptr< MultiFileBase > | multiFile ()
| Get the MultiFile pointer (can be 0).
String | keywordName (const String &keyword) const
| Compose a keyword name from the given keyword appended with the sequence number (e.g.
String | fileName () const
| Compose a unique filename from the table name and sequence number.
ByteIO::OpenOption | fileOption () const
| Get the AipsIO option of the underlying file.
virtual Bool | isRegular () const
| Is this a regular storage manager?
Table & | table () const
| Get the table this object is associated with.
virtual void | reopenRW ()
| Reopen the data manager for read/write access.
virtual Bool | canAddRow () const
| Does the data manager allow to add rows?
virtual Bool | canRemoveRow () const
| Does the data manager allow to delete rows?
virtual Bool | canAddColumn () const
| Does the data manager allow to add columns?
virtual Bool | canRemoveColumn () const
| Does the data manager allow to delete columns?
virtual Bool | canRenameColumn () const
| Does the data manager allow to rename columns?
virtual void | setMaximumCacheSize (uInt nMiB)
| Set the maximum cache size (in bytes) to be used by a storage manager.
virtual void | showCacheStatistics (std::ostream &) const
| Show the data manager's IO statistics.
DataManagerColumn * | createScalarColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a column in the data manager on behalf of a table column.
DataManagerColumn * | createDirArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a direct array column.
DataManagerColumn * | createIndArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create an indirect array column.
DataManager * | getClone () const
| Has the object already been cloned?
void | setClone (DataManager *clone) const
| Set the pointer to the clone.

## Static Public Member Functions

static DataManager * | makeObject (const String &aDataManType, const Record &spec)
Static Public Member Functions inherited from casacore::DataManager
static void | registerCtor (const String &type, DataManagerCtor func)
| Register a mapping of a data manager type to its static construction function.
static DataManagerCtor | getCtor (const String &dataManagerType)
| Get the "constructor" of a data manager (thread-safe).
static Bool | isRegistered (const String &dataManagerType)
| Test if a data manager is registered (thread-safe).
static DataManager * | unknownDataManager (const String &dataManagerType, const Record &spec)
| Serve as default function for theirRegisterMap, which catches all unknown data manager types.

## Static Public Attributes

static constexpr from_config_t | from_config
Static Public Attributes inherited from casacore::DataManager
static rownr_t | MAXROWNR32
| Define the highest row number that can be represented as signed 32-bit.

## Private Member Functions

| Adios2StMan (MPI_Comm mpiComm, std::string engineType, std::map< std::string, std::string > engineParams, std::vector< std::map< std::string, std::string > > transportParams, std::vector< std::map< std::string, std::string > > operatorParams, std::string configFile)
| Adios2StMan (std::string engineType, std::map< std::string, std::string > engineParams, std::vector< std::map< std::string, std::string > > transportParams, std::vector< std::map< std::string, std::string > > operatorParams, std::string configFile)

## Private Attributes

std::unique_ptr< impl > | pimpl

## Friends

class | Adios2StManColumn
template<typename T>
class | Adios2StManColumnT

## Additional Inherited Members

Protected Member Functions inherited from casacore::DataManager
void | decrementNcolumn ()
| Decrement number of columns (in case a column is deleted).
void | setEndian (Bool bigEndian)
| Tell the data manager if big or little endian format is needed.
void | setTsmOption (const TSMOption &tsmOption)
| Tell the data manager which TSM option to use.
void | setMultiFile (const std::shared_ptr< MultiFileBase > &mfile)
| Tell the data manager that MultiFile can be used.
virtual Bool | hasMultiFileSupport () const
| Does the data manager support use of MultiFile?
void | throwDataTypeOther (const String &columnName, int dataType) const
| Throw an exception in case data type is TpOther, because the storage managers (and maybe other data managers) do not support such columns.

## Detailed Description

Definition at line 45 of file Adios2StMan.h.

## Constructor & Destructor Documentation

## Adios2StMan() [1/6]

casacore::Adios2StMan::Adios2StMan | ( | MPI_Comm | mpiComm,
|  | std::string | engineType = {},
|  | std::map< std::string, std::string > | engineParams = {},
|  | std::vector< std::map< std::string, std::string > > | transportParams = {},
|  | std::vector< std::map< std::string, std::string > > | operatorParams = {} )

Referenced by casacore::Adios2StMan::impl::impl().

## Adios2StMan() [2/6]

casacore::Adios2StMan::Adios2StMan | ( | MPI_Comm | mpiComm,
|  | std::string | configFile,
|  | from_config_t | )

## Adios2StMan() [3/6]

casacore::Adios2StMan::Adios2StMan | ( | std::string | engineType = {},
|  | std::map< std::string, std::string > | engineParams = {},
|  | std::vector< std::map< std::string, std::string > > | transportParams = {},
|  | std::vector< std::map< std::string, std::string > > | operatorParams = {} )

## Adios2StMan() [4/6]

casacore::Adios2StMan::Adios2StMan | ( | std::string | configFile,
|  | from_config_t | )

## ~Adios2StMan()

virtual casacore::Adios2StMan::~Adios2StMan | ( |  | ) |

virtual

## Adios2StMan() [5/6]

casacore::Adios2StMan::Adios2StMan | ( | MPI_Comm | mpiComm,
|  | std::string | engineType,
|  | std::map< std::string, std::string > | engineParams,
|  | std::vector< std::map< std::string, std::string > > | transportParams,
|  | std::vector< std::map< std::string, std::string > > | operatorParams,
|  | std::string | configFile )

private

## Adios2StMan() [6/6]

casacore::Adios2StMan::Adios2StMan | ( | std::string | engineType,
|  | std::map< std::string, std::string > | engineParams,
|  | std::vector< std::map< std::string, std::string > > | transportParams,
|  | std::vector< std::map< std::string, std::string > > | operatorParams,
|  | std::string | configFile )

private

## Member Function Documentation

## addRow64()

virtual void casacore::Adios2StMan::addRow64 | ( | rownr_t | nrrow | ) |

virtual

Add rows to all columns.

The default implementation calls the uInt version.

Reimplemented from casacore::DataManager.

## clone()

virtual DataManager * casacore::Adios2StMan::clone | ( |  | ) | const

virtual

Make a clone of the derived object.

Implements casacore::DataManager.

References casacore::DataManager::DataManager().

## create64()

virtual void casacore::Adios2StMan::create64 | ( | rownr_t | nrrow | ) |

virtual

Let the data manager initialize itself for a new table.

The default implementation calls the uInt version.

Reimplemented from casacore::DataManager.

## dataManagerName()

virtual String casacore::Adios2StMan::dataManagerName | ( |  | ) | const

virtual

Return the name of the data manager.

This is the name of this instantiation of the data manager, thus not its type name. By default it returns an empty string.

Reimplemented from casacore::DataManager.

## dataManagerSpec()

Record casacore::Adios2StMan::dataManagerSpec | ( |  | ) | const

virtual

Return a record containing data manager specifications.

The default implementation returns an empty record.

Reimplemented from casacore::DataManager.

References casacore::Record().

## dataManagerType()

virtual String casacore::Adios2StMan::dataManagerType | ( |  | ) | const

virtual

Return the type name of the data manager (in fact its class name).

It has to be a unique name, thus if the class is templated the template parameter has to be part of the name. This is used by the open/flush mechanism to be able to reconstruct the correct data manager.

Implements casacore::DataManager.

## deleteManager()

virtual void casacore::Adios2StMan::deleteManager | ( |  | ) |

virtual

The data manager will be deleted (because all its columns are requested to be deleted).

So clean up the things needed (e.g. delete files).

Implements casacore::DataManager.

## flush()

virtual Bool casacore::Adios2StMan::flush | ( | AipsIO & | ios,
|  | Bool | fsync )

virtual

Flush and optionally fsync the data.

The AipsIO stream represents the main table file and can be used by virtual column engines to store SMALL amounts of data. It returns a True status if it had to flush (i.e. if data have changed).

Implements casacore::DataManager.

## getNrRows()

rownr_t casacore::Adios2StMan::getNrRows | ( |  | ) |

## makeDirArrColumn()

virtual DataManagerColumn * casacore::Adios2StMan::makeDirArrColumn | ( | const String & | columnName,
|  | int | dataType,
|  | const String & | dataTypeId )

virtual

Create a direct array column.

Implements casacore::DataManager.

## makeIndArrColumn()

virtual DataManagerColumn * casacore::Adios2StMan::makeIndArrColumn | ( | const String & | columnName,
|  | int | dataType,
|  | const String & | dataTypeId )

virtual

Create an indirect array column.

Implements casacore::DataManager.

## makeObject()

DataManager * casacore::Adios2StMan::makeObject | ( | const String & | aDataManType,
|  | const Record & | spec )

static

References casacore::DataManager::DataManager(), and casacore::Record().

## makeScalarColumn()

virtual DataManagerColumn * casacore::Adios2StMan::makeScalarColumn | ( | const String & | columnName,
|  | int | dataType,
|  | const String & | dataTypeId )

virtual

Create a column in the data manager on behalf of a table column.

Create a scalar column.

Implements casacore::DataManager.

## open64()

virtual rownr_t casacore::Adios2StMan::open64 | ( | rownr_t | nrrow,
|  | AipsIO & | ios )

virtual

Let the data manager initialize itself for an existing table.

The AipsIO stream represents the main table file and must be used by virtual column engines to retrieve the data stored in the flush function.
The data manager returns 0 or the nr of rows it thinks there are. This is particularly useful for data managers like LofarStMan whose data are written outside the table system, thus for which no rows have been added.
The default implementation calls the uInt version of open and open1.

Reimplemented from casacore::DataManager.

## resync64()

virtual rownr_t casacore::Adios2StMan::resync64 | ( | rownr_t | nrrow | ) |

virtual

Resync the data by rereading cached data from the file.

This is called when a lock is acquired on the file and it appears that data in this data manager has been changed by another process.
The data manager returns 0 or the number of rows it thinks there are. This is particularly useful for data managers like LofarStMan whose data are written outside the table system, thus for which no rows have been added.
The default implementation calls the uInt version of resync and resync1.

Reimplemented from casacore::DataManager.

## setDataManagerName()

void casacore::Adios2StMan::setDataManagerName | ( | const String & | aName | ) |

## Friends And Related Symbol Documentation

## Adios2StManColumn

friend class Adios2StManColumn

friend

Definition at line 47 of file Adios2StMan.h.

References Adios2StManColumn.

Referenced by Adios2StManColumn.

## Adios2StManColumnT

template<typename T>

friend class Adios2StManColumnT

friend

Definition at line 48 of file Adios2StMan.h.

References Adios2StManColumnT.

Referenced by Adios2StManColumnT.

## Member Data Documentation

## from_config

from_config_t casacore::Adios2StMan::from_config

static constexpr

Definition at line 53 of file Adios2StMan.h.

## pimpl

std::unique_ptr<impl> casacore::Adios2StMan::pimpl

private

Definition at line 102 of file Adios2StMan.h.

The documentation for this class was generated from the following file:

- tables/DataMan/Adios2StMan.h